--local addon, private = ...
local addoninfo, umData = ...
local addon = addoninfo.identifier

um_UI = {}
um_OutfitSave = {}

UpgradeMe = {
	_debugon = false, 
	AddonData = Inspect.Addon.Detail("UpgradeMe"),
	Calling = nil,
	StatData = nil,
	OutfitData = nil,
	Outfits = nil,
	Context = UI.CreateContext("UpgradeMe"),
	ttContext = UI.CreateContext("UpgradeMe.TT"),
	ofContext = UI.CreateContext("UpgradeMe.OF"),
	UI = nil,
	Config = nil,
	Tooltip = nil,
	SelectedOutfit = nil,
	LeftDown = false,
	RightDown = false, 
	x_tip = 0,
	y_tip = 0,
	debug = false,
	flgTooltip = false,
	OutfitDirty = true,
	CallingUpdates = "~none~",
	SystemLocked = false,
	GetItemDetail = function(_itm)
		local _ret = nil
		local _ok = nil
		
		_ok, _ret = pcall(Inspect.Item.Detail, _itm)
		if not (_ok and _ret) then _ok, _ret = pcall(Inspect.Item.Detail, _itm) end
		
		return _ret
	end,
	GetUnitDetail = function(_unit)
		local _ret = nil
		local _ok = nil
		
		_ok, _ret = pcall(Inspect.Unit.Detail, _unit)
		if not (_ok and _ret) then _ok, _ret = pcall(Inspect.Unit.Detail, _unit) end
		
		return _ret
	end,
	GearInSet = function(_id, _slot)
		local _ret = false
		local _slotname = ""
		if _slot ~= "twohand" then _slotname = _slot else _slotname = "handmain" end

		local _idetail = UpgradeMe.GetItemDetail(Utility.Item.Slot.Equipment(_slotname))

		if _idetail then
			if _id == _idetail.id then _ret = true end
		elseif not _id then
			_ret = true
		end
		return _ret
	end,
	GetOutfit = function(_outfit)
		if not UpgradeMe.UI.OutfitFrame.Outfits then return nil end
		local _ret = nil
		
		for i, j in pairs(UpgradeMe.UI.OutfitFrame.Outfits) do
			if j.GetOutfitName() == _outfit["Name"] then	
				_ret = j 
				break
			end	
		end
		
		return _ret
	end,
	GetMiddleMacro = function(_of)
		local _ret = ""
		local _val = ""
		
		if _of["Role"] then
			_val = _of["Role"]
			_ret = string.format ('role %s', _val)				
		end
		
		if _of["GearSet"] then
			_val = _of["GearSet"]
			if _ret ~= "" then _ret = _ret.."\n" end
			_ret = _ret..string.format ('loadequip %s', _val)				
		end

		if _of["Wardrobe"] then
			_val = _of["Wardrobe"]
			if _ret ~= "" then _ret = _ret.."\n" end
			_ret = _ret..string.format ('wardrobe %s', _val)				
		end
		
		return _ret
	end,
	GetCurrentOutfits = function()
		if Inspect.System.Secure() then return end
		local _count = 0
		if UpgradeMe.UI.OutfitFrame.Outfits then _count = #UpgradeMe.UI.OutfitFrame.Outfits end
		
		for i, j in pairs(UpgradeMe.UI.OutfitFrame.Outfits) do
			j.Text:SetVisible(false)
			j.Button:SetVisible(false)
		end
		
		for i, j in pairs(UpgradeMe.Outfits) do
			local _owidget = UpgradeMe.GetOutfit(j)
			if not _owidget then
				_count = _count + 1
				_owidget = CreateOutfitWidget(UpgradeMe.UI.OutfitFrame, j, _count)
				table.insert(UpgradeMe.UI.OutfitFrame.Outfits, _owidget)
			end
			
			if not Inspect.System.Secure() then
				local _macro = UpgradeMe.GetMiddleMacro(j)
				_owidget.Text:EventMacroSet(Event.UI.Input.Mouse.Middle.Click, nil)
				_owidget.Text:EventMacroSet(Event.UI.Input.Mouse.Left.Click, nil)
				_owidget.Text:EventMacroSet(Event.UI.Input.Mouse.Right.Click, nil)				
				
				_owidget.Text:EventDetach(Event.UI.Input.Mouse.Left.Up, nil, i.."widgetleftup")
				_owidget.Text:EventDetach(Event.UI.Input.Mouse.Right.Up, nil, i.."widgetrightup")
				_owidget.Text:EventDetach(Event.UI.Input.Mouse.Middle.Up, nil, i.."widgetmiddleup")
				_owidget.Text:EventDetach(Event.UI.Input.Mouse.Left.Click, nil, i.."wigetleftclick")
				_owidget.Text:EventDetach(Event.UI.Input.Mouse.Right.Click, nil, i.."wigetrightclick")
				
				_owidget.OutfitGearSet = j["GearSet"]
				_owidget.OutfitRoleSlot = j["Role"]
				_owidget.OutfitWardrobeSet = j["Wardrobe"]	
				
				if _owidget.OutfitGearSet and _owidget.OutfitGearSet ~= 0 then
					_owidget.Text:EventMacroSet(Event.UI.Input.Mouse.Middle.Click, _macro)				
					_owidget.Text:EventMacroSet(Event.UI.Input.Mouse.Left.Click, string.format ('loadequip %s', _owidget.OutfitGearSet))			
					_owidget.Text:EventMacroSet(Event.UI.Input.Mouse.Right.Click, string.format ('saveequip %s', _owidget.OutfitGearSet))	

					_owidget.Text:EventAttach(Event.UI.Input.Mouse.Left.Up, 
						function(_self, val)
							if Inspect.System.Secure() then
								print("In combat "..i.." could not be loaded.")
							else
								UpgradeMe.UI.OutfitFrame:SelectOutfit(_owidget)
								print(i.." Loaded.")
							end
						end, i.."widgetleftup")
					_owidget.Text:EventAttach(Event.UI.Input.Mouse.Right.Up, 
						function(_self, val)
							if Inspect.System.Secure() then
								 print("In combat "..i.." could not be saved.")
							else
								UpgradeMe.Config:SaveOutfit(i, true)
							end
						end, i.."widgetrightup")	
					_owidget.Text:EventAttach(Event.UI.Input.Mouse.Middle.Up, 
						function(_self, val)
							if Inspect.System.Secure() then
								print("In combat "..i.." could not be loaded and role could not be changed.")
							else
								UpgradeMe.UI.OutfitFrame:SelectOutfit(_owidget)
								print(string.format("%s Loaded - Role: %s  GearSet: %s  Wardrobe: %s", tostring(i), tostring(_owidget.OutfitRoleSlot), tostring(_owidget.OutfitGearSet), tostring(_owidget.OutfitWardrobeSet)))
							end
						end, i.."widgetmiddleup")		
				else
					_owidget.Text:EventAttach(Event.UI.Input.Mouse.Left.Click, 
						function(_self, val) 
							print("No gear set selected.  Cannot loadequip.")
						end, i.."wigetleftclick")
					_owidget.Text:EventAttach(Event.UI.Input.Mouse.Right.Click, 
						function(_self, val) 
							print("No gear set selected.  Cannot saveequip.")
						end, i.."wigetrightclick")		
				end
				_owidget.Text:SetVisible(true)
				_owidget.Button:SetVisible(true)
			else
				_owidget.Text:SetVisible(true)
				_owidget.Button:SetVisible(true)			
			end
		end
		
		for i, j in pairs(UpgradeMe.UI.OutfitFrame.Outfits) do
			if not j.Text:GetVisible() then table.remove(UpgradeMe.UI.OutfitFrame.Outfits, i) end
		end
		
		for i, j in pairs(UpgradeMe.UI.OutfitFrame.Outfits) do
			j.Text:ClearAll()
			j.Button:ClearAll()	
			if j.Text:GetVisible() then 
				j.Text:SetPoint("TOPLEFT", UpgradeMe.UI.OutfitFrame, "TOPLEFT", 5, 5 + (((i-1) * 25)))
				j.Text:SetPoint("BOTTOMRIGHT", UpgradeMe.UI.OutfitFrame, "TOPRIGHT", -5, i * 25)
				j.Button:SetPoint("TOPLEFT", j.Text, "TOPLEFT")
				j.Button:SetPoint("BOTTOMRIGHT", j.Text, "BOTTOMRIGHT")	
			end
		end
		
		_count = 0
		if UpgradeMe.UI.OutfitFrame.Outfits then _count = #UpgradeMe.UI.OutfitFrame.Outfits end
		UpgradeMe.UI.OutfitFrame:SetHeight((_count*25)+5)
		
		return UpgradeMe.UI.OutfitFrame.Outfits
	end,	
	ValidateOutfit = function()
		local _found = true
		local _ret = nil
		
		UpgradeMe.flgTooltip = true
		
		for _oname, _outfit in pairs(UpgradeMe.Outfits) do
			_found = true
			for _slot, _item in pairs(_outfit["OutfitItems"]) do
				if not UpgradeMe.GearInSet(_item["ID"], _slot) then
					_found = false
				end
			end
			if _found then 
				UpgradeMe.flgTooltip = false 
				_ret = _outfit
			end
		end
		UpgradeMe.OutfitDirty = false
		return _ret
	end,
	SetUI = function()
		if Inspect.System.Secure() then return end
		UpgradeMe.UI.TipAnchorFrame:SetAnchorPoint()
		UpgradeMe.UI.TipAnchorFrame:SetVisible(not umData.um_UI.Locked)
		
		local _w = UpgradeMe.UI.OutfitFrame:GetWidth()
		local _h = UpgradeMe.UI.OutfitFrame:GetHeight()
		UpgradeMe.UI.OutfitFrame:ClearAll()
		UpgradeMe.UI.OutfitFrame:SetWidth(_w)
		UpgradeMe.UI.OutfitFrame:SetHeight(_h)
		
		local _anchor = umData.um_UI.FrameAnchor
		if _anchor == "TOPLEFT" then
			UpgradeMe.UI.OutfitFrame:SetPoint("BOTTOMRIGHT", UpgradeMe.UI.Icon, "CENTER", 0, 0)
		elseif _anchor == "TOPRIGHT" then
			UpgradeMe.UI.OutfitFrame:SetPoint("BOTTOMLEFT", UpgradeMe.UI.Icon, "CENTER", 0, 0)
		elseif _anchor == "BOTTOMLEFT" then
			UpgradeMe.UI.OutfitFrame:SetPoint("TOPRIGHT", UpgradeMe.UI.Icon, "CENTER", 0, 0)
		elseif _anchor == "BOTTOMRIGHT" then
			UpgradeMe.UI.OutfitFrame:SetPoint("TOPLEFT", UpgradeMe.UI.Icon, "CENTER", 0, 0)
		end		
	end,
}

UpgradeMe.Context:SetSecureMode("restricted")
UpgradeMe.ofContext:SetSecureMode("restricted")

local function trim(_s)
	return _s:find'^%s*$' and '' or _s:match'^%s*(.*%S)'
end

local function RoundValue(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

local function getItemSlotName(_itm)
	if not _itm then return nil end
	
	local _slot = nil
	if string.find(_itm, "head") or (_itm == "seqp.hlm") then
		_slot =  "helmet"
	elseif string.find(_itm, "cape") or (_itm == "seqp.cpe") then
		_slot =  "cape"
	elseif string.find(_itm, "shoulders") or (_itm == "seqp.shl") then
		_slot =  "shoulders"
	elseif string.find(_itm, "chest") or (_itm == "seqp.chs") then
		_slot =  "chest"
	elseif string.find(_itm, "hands") or (_itm == "seqp.glv") then
		_slot =  "gloves"
	elseif string.find(_itm, "waist") or (_itm =="seqp.blt") then
		_slot =  "belt"
	elseif string.find(_itm, "legs") or (_itm =="seqp.lgs") then
		_slot =  "legs"
	elseif string.find(_itm, "feet") or (_itm =="seqp.fet") then
		_slot =  "feet"
	elseif string.find(_itm, "onehand") or (_itm =="seqp.hmn") then
		_slot =  "handmain"
	elseif string.find(_itm, "twohand") then
		_slot =  "twohand"
	elseif string.find(_itm, "offhand") or string.find(_itm, "totem") or string.find(_itm, "shield") or (_itm =="seqp.hof") then
		_slot =  "handoff"
	elseif string.find(_itm, "ranged") or (_itm =="seqp.rng") then
		_slot =  "ranged"
	elseif string.find(_itm, "neck") or (_itm =="seqp.nck") then
		_slot =  "neck"
	elseif string.find(_itm, "trinket") or (_itm =="seqp.tkt") then
		_slot =  "trinket"
	elseif string.find(_itm, " ring") or string.find(_itm, "seqp.rn") then
		_slot =  "ring"
	elseif string.find(_itm, "synergy") or (_itm =="seqp.syn") then
		_slot =  "synergy"
	elseif string.find(_itm, "focus") or (_itm =="seqp.fcs") then
		_slot =  "focus"
	elseif string.find(_itm, "seal") or (_itm =="seqp.sel") then
		_slot =  "seal"
	end

	return _slot
end

local function getItemScore(_ofit, _itm, _slot)
	local _score = 0
	local _detail = nil
	local _dps = 0
	
	_detail = UpgradeMe.GetItemDetail(_itm)
	
	_score = -1
	--_detail = Inspect.Item.Detail(_itm)
	if _detail and _detail.stats then
		_score = 0
		for statname, statrec in pairs(_ofit["OutfitWeights"]) do
			if _detail.stats[statname] then
				_score = _score + (_detail.stats[statname..""] * statrec["StatWeight1"])
			end
			if _detail.damageMax and statname == "WeaponDPS" then
				_dps = ((((_detail.damageMin + _detail.damageMax)/2)/_detail.damageDelay) * statrec["StatWeight1"])
				if _slot then
					if _slot == "handmain" then  _dps = _dps * 1.3 else _dps = 0 end
				end 
				_score = _score + _dps
			end
		end
	end

	return RoundValue(_score, 0)
end

local function HideTooltip(_event, _x, _y)
	local mouse = Inspect.Mouse()
	if mouse.Right then UpgradeMe.RightDown = true else UpgradeMe.RightDown = false end
	if mouse.Left then UpgradeMe.LeftDown = true else UpgradeMe.LeftDown = false end

	if not UpgradeMe.Tooltip then return end
	if UpgradeMe.UI.OutfitFrame:GetVisible() then UpgradeMe.UI.OutfitFrame:ShowFrame() end
	if not UpgradeMe.Tooltip:GetVisible() then return end
		
	if math.abs(_x - UpgradeMe.x_tip) > 30 or math.abs(_y - UpgradeMe.y_tip) > 30 then
		UpgradeMe.Tooltip:Hide()
		_display = false
	end
end

local function SetOutfitDirty(_event, _updates)
	for _slot, _id in pairs(_updates) do
		if string.find(_slot, "seqp.") then UpgradeMe.OutfitDirty = true end
	end
end

function CreateOutfitWidget(_owner, _outfit, i)
	if not _outfit then return end
	
	local _ret = {}
	_ret.OutfitName = _outfit["Name"]
	_ret.OutfitGearSet = _outfit["GearSet"]
	_ret.OutfitRoleSlot = _outfit["Role"]
	_ret.OutfitWardrobeSet = _outfit["Wardrobe"]
	_ret.Text = UI.CreateFrame("Text", _outfit["Name"].."widgettext", _owner)
	_ret.Text:SetLayer(1)
	_ret.Text:SetSecureMode("restricted")
	_ret.Text:SetText(_outfit["Name"])
	if _owner:GetWidth() < _ret.Text:GetWidth() then _owner:SetWidth(_ret.Text:GetWidth() + 10) end
	_ret.Text:SetPoint("TOPLEFT", _owner, "TOPLEFT", 5, 5 + (((i-1) * 25)))
	_ret.Text:SetPoint("BOTTOMRIGHT", _owner, "TOPRIGHT", -5, i * 25)
	_ret.Text:SetBackgroundColor(0, 0, 0, 1)
	_ret.SetBackgroundColor = function(_self, r, g, b, y) 
		_ret.Text:SetBackgroundColor(r, g, b, y)
	end
	_ret.SetBackground = function(_self, _color) 
		_ret.Button:SetTexture("UpgradeMe", string.format("textures/%s.png", _color))
	end
	_ret.GetOutfitName = function()
		return _ret.Text:GetText()
	end
	_ret.Text:EventAttach(Event.UI.Input.Mouse.Cursor.In, 
		function(_self, val) 
			_self:SetBackgroundColor(0, 0, 1, .7)
			_owner:ShowFrame() 
		end, _outfit["Name"].."wigetmousein")
	_ret.Text:EventAttach(Event.UI.Input.Mouse.Cursor.Out, 
		function(_self, val) 
			if _self ~= UpgradeMe.SelectedOutfit then _self:SetBackgroundColor(0, 0, 0, 1) else _self:SetBackgroundColor(0, 1, 0, .3) end
			_owner:ShowFrame() 
		end, _outfit["Name"].."wigetmouseout")
	_ret.Button = UI.CreateFrame("Texture", _outfit["Name"].."widgetimg", _owner)
	_ret.Button:SetLayer(2)
	_ret.Button:SetPoint("TOPLEFT", _ret.Text, "TOPLEFT")
	_ret.Button:SetPoint("BOTTOMRIGHT", _ret.Text, "BOTTOMRIGHT")
	_ret.Button:SetVisible(true)
	_ret.Button:SetTexture("UpgradeMe", "textures/white.png")

	return _ret
end

local function scrapeTooltip(_event, _ttype, _titem, _tbuff)
	if _ttype ~= "item" and _ttype ~= "itemtype" then return end
	local _dropslot = nil
	local _tscore = nil
	local _escore = 0
	local _escore2 = 0
	local _umtip = ""
	local _umicon = ""
	local _bOutfitsLoaded = false
	
	local _detail = UpgradeMe.GetItemDetail(_titem)

	if not _detail then return end
	if not UpgradeMe.Outfits then return end
	--if #UpgradeMe.Outfits == 0 then return end
	
	if _detail.requiredCalling then
		if not string.find(_detail.requiredCalling, UpgradeMe.Calling) then return end
	end
	
	_dropslot = getItemSlotName(_detail.category)

	if not _dropslot then return end
	
	if (UpgradeMe.RightDown or UpgradeMe.LeftDown) and (not umData.um_UI.Locked) then
		local _dirty = false
		
		if _dropslot == "handmain" and UpgradeMe.LeftDown then 
			umData.um_UI.HandMainID = _titem
			_dirty = true
			print(_detail.name.." saved as default main hand.")
		end
		
		if _dropslot == "handoff" or (_dropslot == "handmain" and (UpgradeMe.Calling == "rogue" or UpgradeMe.Calling == "warrior")) and UpgradeMe.RightDown then 
			umData.um_UI.HandOffID = _titem
			_dirty = true
			print(_detail.name.." saved as default off hand.")
		end
		if _dirty then UpgradeMe.Config:LoadOutfitDefaults() end
	end
	
	UpgradeMe.Tooltip:Hide()

	UpgradeMe.Tooltip:ClearTips()
	
	local _outfititemscore1 = 0
	local _dropitemscore1 = 0
	local _dropitemscore2 = 0
	local _infotext = ""
	local _outfittext = ""
	local _outfitslot = ""
	local _bOutfitItem = false
	local _bOutfitTwoHand = false
	local _bDoubleWieldCalling = ((UpgradeMe.Calling == "warrior") or (UpgradeMe.Calling == "rogue"))
	local _bInOutfit = false
	local _ohTypeDetail = nil
	
	for oname, outfit in pairs(UpgradeMe.Outfits) do
		_bOutfitsLoaded = true
		_outfititemscore1 = 0
		_outfititemscore2 = 0
		_dropitemscore1 = 0
		_dropitemscore2 =  0
		_infotext = ""
		_bInOutfit = false
		_ohTypeDetail = nil
		
		_bOutfitTwoHand = ((outfit["OutfitItems"]["twohand"]) and (outfit["OutfitItems"]["twohand"]["ID"]))
		_bOutfitItem = ((outfit["OutfitItems"][_dropslot..""]) and (outfit["OutfitItems"][_dropslot..""]["ID"]))
		
		
		_dropitemscore1 = getItemScore(outfit, _titem)	
		_umtip = "Outfit - "..oname.. ": "
		_umicon = ""
		
		if _dropslot == "ring" then
			if outfit["OutfitItems"]["ring1"] and _titem == outfit["OutfitItems"]["ring1"]["ID"] then _bInOutfit = true end
			if outfit["OutfitItems"]["ring2"] and _titem == outfit["OutfitItems"]["ring2"]["ID"] then _bInOutfit = true end
		else
			if outfit["OutfitItems"][_dropslot..""] and _titem == outfit["OutfitItems"][_dropslot..""]["ID"] then _bInOutfit = true end
			if outfit["OutfitItems"]["handoff"] and _titem == outfit["OutfitItems"]["handoff"]["ID"] then _bInOutfit = true end
		end
		
		--if UpgradeMe._debugon then print(string.format("%s  -  Drop Slot: %s   Outfit2Hand: %s   Double Wielder: %s", oname, tostring(_dropslot), tostring(_bOutfitTwoHand), tostring(_bDoubleWieldCalling))) end
		if _dropslot == "handmain" then
			if _bOutfitTwoHand then --- figure out wording for default weapon
				_outfititemscore1 = _outfititemscore1 + getItemScore(outfit, outfit["OutfitItems"]["twohand"]["ID"])
				_dropitemscore2 =  getItemScore(outfit, umData.um_UI.HandOffID)
				if _dropitemscore2 == -1 then getItemScore(outfit, umData.um_UI.HandOffID) end
				if _dropitemscore2 < 1 then _dropitemscore1 = -1 else _dropitemscore1 = _dropitemscore1 + _dropitemscore2 end	
				if _dropitemscore1 ~= -1 then _infotext = "(using default off hand)" else _infotext = "(server error - please try again)" end
			elseif _bDoubleWieldCalling then
				_dropitemscore2 = getItemScore(outfit, _titem, "handoff")
				if outfit["OutfitItems"]["handoff"] and outfit["OutfitItems"]["handoff"]["ID"] then 
					_outfititemscore2 = getItemScore(outfit, outfit["OutfitItems"]["handoff"]["ID"], "handoff") 
					
					_ohTypeDetail = UpgradeMe.GetItemDetail(outfit["OutfitItems"]["handoff"]["ID"])
					if _ohTypeDetail and _ohTypeDetail.damageMax then 
						_dropitemscore1 = getItemScore(outfit, _titem, "handmain")	
						_outfititemscore1 = getItemScore(outfit, outfit["OutfitItems"]["handmain"]["ID"], "handmain")
					else
						if _bOutfitItem then _outfititemscore1 = getItemScore(outfit, outfit["OutfitItems"]["handmain"]["ID"]) end
					end
				else
					if _bOutfitItem then _outfititemscore1 = getItemScore(outfit, outfit["OutfitItems"]["handmain"]["ID"]) end
				end
			else
				if _bOutfitItem then _outfititemscore1 = getItemScore(outfit, outfit["OutfitItems"]["handmain"]["ID"]) end
			end
			
			if _dropitemscore1 == -1 then 
				_infotext = ""
				_umtip = _umtip..'<font color="#cc0000">No default off hand to pair with.</font>'
			elseif _bDoubleWieldCalling then
				if _bOutfitTwoHand then
					_infotext = "(using default main hand)"
					if _dropitemscore1 > _outfititemscore1 then
						_umicon = "Up"
						_umtip = _umtip..'<font color="#00cc00">('.._dropitemscore1..'/'.._outfititemscore1..') +'..(_dropitemscore1-_outfititemscore1)..'</font>'
					elseif _dropitemscore1 == _outfititemscore1 then
						_umicon = "Side"
						_umtip = _umtip..'<font color="#fff600">Equal</font>'
					else
						_umicon = "Down"
						_umtip = _umtip..'<font color="#cc0000">('.._dropitemscore1..'/'.._outfititemscore1..') -'..(_outfititemscore1 - _dropitemscore1)..'</font>'
					end
				else
					-- Main Hand
					if _dropitemscore1 > _outfititemscore1 then 
						_umtip = _umtip..'<font color="#00cc00">Main Hand ('.._dropitemscore1..'/'.._outfititemscore1..') +'..(_dropitemscore1-_outfititemscore1)..'</font>'
					elseif _dropitemscore1 == _outfititemscore1 then
						_umtip = _umtip..'<font color="#fff600">Main Hand - Equal</font>'
					else
						_umtip = _umtip..'<font color="#cc0000">Main Hand ('.._dropitemscore1..'/'.._outfititemscore1..') -'..(_outfititemscore1 - _dropitemscore1)..'</font>'
					end
					
					-- Off Hand
					if _dropitemscore2 > _outfititemscore2 then 
						_umtip = _umtip..';  <font color="#00cc00">Off Hand ('.._dropitemscore2..'/'.._outfititemscore2..') +'..(_dropitemscore2-_outfititemscore2)..'</font>'
					elseif _dropitemscore2 == _outfititemscore2 then
						_umtip = _umtip..';  <font color="#fff600">Off Hand - Equal</font>'
					else
						_umtip = _umtip..';  <font color="#cc0000">Off Hand ('.._dropitemscore2..'/'.._outfititemscore2..') -'..(_outfititemscore2 - _dropitemscore2)..'</font>'
					end		
					
					-- Icon 
					if _dropitemscore == -1 then
					elseif _dropitemscore1 > _outfititemscore1 or _dropitemscore2 > _outfititemscore2 then
						_umicon = "Up"
					elseif _dropitemscore1 < _outfititemscore1 and _dropitemscore2 < _outfititemscore2 then
						_umicon = "Down"
					else
						_umicon = "Side"
					end	
				end
			end
		elseif _dropslot == "handoff" then
			if _bOutfitTwoHand then --- figure out wording for default weapon
				_outfititemscore1 = _outfititemscore1 + getItemScore(outfit, outfit["OutfitItems"]["twohand"]["ID"])
				_dropitemscore2 =  getItemScore(outfit, umData.um_UI.HandMainID)
				if _dropitemscore2 == -1 then getItemScore(outfit, umData.um_UI.HandMainID) end
				if _dropitemscore2 < 1 then _dropitemscore1 = -1 else _dropitemscore1 = _dropitemscore1 + _dropitemscore2 end	
				if _dropitemscore1 ~= -1 then _infotext = "(using default main hand)" else _infotext = "(server error - please try again)" end		
			else
				if _bOutfitItem then _outfititemscore1 = getItemScore(outfit, outfit["OutfitItems"]["handoff"]["ID"]) end
			end

			if _dropitemscore1 == -1 then 
				_infotext = ""
				_umtip = _umtip..'<font color="#cc0000"> - No default main hand to pair with.</font>' 
			end
		elseif _dropslot == "twohand" then
			if _bOutfitTwoHand then 
				_outfititemscore1 = _outfititemscore1 + getItemScore(outfit, outfit["OutfitItems"]["twohand"]["ID"])
			else
				if outfit["OutfitItems"]["handmain"] and outfit["OutfitItems"]["handmain"]["ID"] then _outfititemscore1 = getItemScore(outfit, outfit["OutfitItems"]["handmain"]["ID"], "handmain") end
				if outfit["OutfitItems"]["handoff"] and outfit["OutfitItems"]["handoff"]["ID"] then _outfititemscore1 = _outfititemscore1 + getItemScore(outfit, outfit["OutfitItems"]["handoff"]["ID"], "handoff") end
			end			
		elseif _dropslot == "ring" then
			if outfit["OutfitItems"]["ring1"] and outfit["OutfitItems"]["ring1"]["ID"] then _outfititemscore1 = getItemScore(outfit, outfit["OutfitItems"]["ring1"]["ID"]) end
			if outfit["OutfitItems"]["ring2"] and outfit["OutfitItems"]["ring2"]["ID"] then _outfititemscore2 = getItemScore(outfit, outfit["OutfitItems"]["ring2"]["ID"]) end		
			
			-- Ring 1
			if _dropitemscore1 > _outfititemscore1 then 
				_umtip = _umtip..'<font color="#00cc00">Ring 1 ('.._dropitemscore1..'/'.._outfititemscore1..') +'..(_dropitemscore1-_outfititemscore1)..'</font>'
			elseif _dropitemscore1 == _outfititemscore1 then
				_umtip = _umtip..'<font color="#fff600">Ring 1 - Equal</font>'
			else
				_umtip = _umtip..'<font color="#cc0000">Ring 1 ('.._dropitemscore1..'/'.._outfititemscore1..') -'..(_outfititemscore1 - _dropitemscore1)..'</font>'
			end

			-- Ring 2
			if _dropitemscore1 > _outfititemscore2 then 
				_umtip = _umtip..';  <font color="#00cc00">Ring 2 ('.._dropitemscore1..'/'.._outfititemscore2..') +'..(_dropitemscore1-_outfititemscore2)..'</font>'
			elseif _dropitemscore1 == _outfititemscore2 then
				_umtip = _umtip..';  <font color="#fff600">Ring 2 - Equal</font>'
			else
				_umtip = _umtip..';  <font color="#cc0000">Ring 2 ('.._dropitemscore1..'/'.._outfititemscore2..') -'..(_outfititemscore2 - _dropitemscore1)..'</font>'
			end				 
			
			-- Icon
			if _dropitemscore1 > _outfititemscore1 or _dropitemscore1 > _outfititemscore2 then
				_umicon = "Up"
			elseif _dropitemscore1 < _outfititemscore1 and _dropitemscore1 < _outfititemscore2 then
				_umicon = "Down"
			else
				_umicon = "Side"
			end				
		else
			 if _bOutfitItem then _outfititemscore1 = getItemScore(outfit, outfit["OutfitItems"][_dropslot..""]["ID"]) end
		end
		
		--local _marked = '<font color="#ffffff">&nbsp;&nbsp;**</font>'
		--if not _bInOutfit then _marked = "" end
		
		if _umicon == "" then
			if _dropitemscore1 == -1 then
				_umicon = "Down"		
			elseif _dropitemscore1 > _outfititemscore1 then 
				_umicon = "Up"
				_umtip = _umtip..'<font color="#00cc00">('.._dropitemscore1..'/'.._outfititemscore1..') +'..(_dropitemscore1-_outfititemscore1)..'</font>'--.._marked
			elseif _dropitemscore1 == _outfititemscore1 then
				_umicon = "Side"
				_umtip = _umtip..'<font color="#fff600">Equal</font>'--.._marked
			else
				_umicon = "Down"
				_umtip = _umtip..'<font color="#cc0000">('.._dropitemscore1..'/'.._outfititemscore1..') -'..(_outfititemscore1 - _dropitemscore1)..'</font>'--.._marked
			end			
		end
		
		if _infotext ~= "" then _umtip = _umtip.." ".._infotext end
		
		UpgradeMe.Tooltip:AddTip(_umtip, _umicon, _bInOutfit)
	end	
	if UpgradeMe.OutfitDirty then UpgradeMe.ValidateOutfit() end
	
	if not _bOutfitsLoaded then UpgradeMe.Tooltip:AddTip("No Saved Outfits", "Down") end
	if _outfittext == "" then _outfittext = "This item is not in any of your outfits." end
	UpgradeMe.Tooltip.Footer = _outfittext
	
	UpgradeMe.Tooltip:Show(UpgradeMe.UI.TipAnchorFrame, umData.um_UI.TooltipAnchor)
	UpgradeMe.y_tip = Inspect.Mouse()["y"]
	UpgradeMe.x_tip = Inspect.Mouse()["x"]
end

local function PlayerLoaded(_event, _players)
	local _player = nil
	
	for i, j in pairs(_players) do
		if Inspect.Unit.Lookup(i) == "player" then 
			playerloaded = true 
			_player = i
			break
		end
	end
	if not _player then return end
	
	local _pdetail = UpgradeMe.GetUnitDetail(_player)
	if not _pdetail then return end
	
	UpgradeMe.Calling = _pdetail.calling

	if UpgradeMe.Calling and UpgradeMe.CallingUpdates:find(tostring(UpgradeMe.Calling)) and umData.um_UI.Version ~= tostring(UpgradeMe.AddonData.toc.Version) then
		--UpgradeMe.Config:Show(1)
	end
	umData.um_UI.Version = tostring(UpgradeMe.AddonData.toc.Version)

	local curOutfit = UpgradeMe.ValidateOutfit()
	if curOutfit then 
		local wOutfit = UpgradeMe.GetOutfit(curOutfit)
		UpgradeMe.UI.OutfitFrame:SelectOutfit(wOutfit)
	end
	
	Command.Event.Detach(Event.Unit.Availability.Full, PlayerLoaded, addon..".Update")
end

local function DefaultSettings()
	if umData.um_UI.Version == nil then umData.um_UI.Version = addoninfo.toc.Version end 
	if umData.um_UI.Locked == nil then umData.um_UI.Locked = false end
	if umData.um_UI.UseDocker == nil then umData.um_UI.UseDocker = false end
	if umData.um_UI.X == nil then umData.um_UI.X = (UIParent:GetWidth() / 2) end
	if umData.um_UI.Y == nil then umData.um_UI.Y = (UIParent:GetHeight() / 2) end
	if umData.um_UI.TipX == nil then umData.um_UI.TipX = (UIParent:GetWidth() / 2) end
	if umData.um_UI.TipY == nil then umData.um_UI.TipY = (UIParent:GetHeight() / 2) end
	if umData.um_UI.Scale == nil then umData.um_UI.Scale = 1 end
	if umData.um_UI.TooltipAnchor == nil then umData.um_UI.TooltipAnchor = "TOOLTIP" end
	if umData.um_UI.FrameAnchor == nil then umData.um_UI.FrameAnchor = "BOTTOMRIGHT" end
	if umData.um_UI.HandMainID == nil then umData.um_UI.HandMainID = "" end
	if umData.um_UI.HandOffID == nil then umData.um_UI.HandOffID = "" end
	local _fl = nill
	if umData.um_UI.HandMainID ~= "" then _fl = getItemScore(umData.um_UI.HandMainID) end
	if umData.um_UI.HandOffID ~= "" then _fl = getItemScore(umData.um_UI.HandOffID) end
end

local function LoadVariables(_event, _addon)
	if _addon ~= "UpgradeMe" then return end

	umData.um_UI = _G["um_UI"] or {}
	DefaultSettings()
	
	UpgradeMe.Outfits = {}

	if #um_OutfitSave == 0 then return end
	for oNum, outfit in pairs(um_OutfitSave) do
		if type(outfit[3]) == "table" then
			UpgradeMe.Outfits[outfit[1]..""] = {["Name"]=outfit[1], ["Description"]=outfit[2], ["GearSet"]=nil, ["Role"]=nil, ["Wardrobe"]=nil, ["p2"]=nil, ["p3"]=nil, ["p4"]=nil, ["p5"]=nil, ["OutfitItems"]={}, ["OutfitWeights"]={}}
			for oItem, item in pairs(outfit[3]) do
				if item[3] then
					UpgradeMe.Outfits[outfit[1]..""]["OutfitItems"][item[1]..""] = {["Slot"]=item[1], ["Name"]=item[2], ["ID"]=item[3]}
				end
			end

			for oWeight, weight in pairs(outfit[4]) do
				UpgradeMe.Outfits[outfit[1]..""]["OutfitWeights"][weight[1]..""] = {["StatName"]=weight[1], ["StatWeight1"]=weight[2], ["StatCap"]=weight[3], ["StatWeight2"]=weight[4]}
			end				
		else
			UpgradeMe.Outfits[outfit[1]..""] = {["Name"]=outfit[1], ["Description"]=outfit[2], ["GearSet"]=outfit[3], ["Role"]=outfit[4], ["Wardrobe"]=outfit[5], ["p2"]=outfit[6], ["p3"]=outfit[7], ["p4"]=outfit[8], ["p5"]=outfit[9], ["OutfitItems"]={}, ["OutfitWeights"]={}}
			for oItem, item in pairs(outfit[10]) do
				if item[3] then
					UpgradeMe.Outfits[outfit[1]..""]["OutfitItems"][item[1]..""] = {["Slot"]=item[1], ["Name"]=item[2], ["ID"]=item[3]}
				end
			end

			for oWeight, weight in pairs(outfit[11]) do
				UpgradeMe.Outfits[outfit[1]..""]["OutfitWeights"][weight[1]..""] = {["StatName"]=weight[1], ["StatWeight1"]=weight[2], ["StatCap"]=weight[3], ["StatWeight2"]=weight[4]}
			end				
		end
	end
end

local function SaveVariables(_event, _addon)
	if _addon ~= "UpgradeMe" then return end
	
	_G["um_UI"] = umData.um_UI
	
	um_OutfitSave  = {}
	
	for oName, outfit in pairs(UpgradeMe.Outfits) do
		table.insert(um_OutfitSave, {outfit["Name"], outfit["Description"], outfit["GearSet"], outfit["Role"], outfit["Wardrobe"], outfit["p2"], outfit["p3"], outfit["p4"], outfit["p5"], {}, {}})
		for oItem, item in pairs(outfit["OutfitItems"]) do
			if item["Slot"] ~= "DELETE" then table.insert(um_OutfitSave[#um_OutfitSave][10], {item["Slot"], item["Name"], item["ID"]}) end
		end

		for oWeight, weight in pairs(outfit["OutfitWeights"]) do
			table.insert(um_OutfitSave[#um_OutfitSave][11], {weight["StatName"], weight["StatWeight1"], weight["StatCap"], weight["StatWeight2"]})
		end
	end
end

local function LoadComplete(self, _add)
	if _add ~= addon then return end
	
	UpgradeMe.StatData = GetStatData()
	UpgradeMe.OutfitData = GetOutfitData()
	UpgradeMe.UI = InitUMUI(UpgradeMe.Context)	
	UpgradeMe.Config = GetConfig(UpgradeMe.Context, UpgradeMe.StatData)
	UpgradeMe.Config.Event.Close = function() UpgradeMe.Config:Hide() end
	UpgradeMe.Tooltip = umTooltip(UpgradeMe.ttContext, UpgradeMe.OutfitData:OutfitCount())
	UpgradeMe.UI.OutfitFrame.Outfits = UpgradeMe.GetCurrentOutfits()
	UpgradeMe:SetUI()

	print(string.format("UpgradeMe v.%s loaded.", umData.um_UI.Version))
end

local function SlashHandler(_event, _args)
	args = trim(_args)
	if not args or args == "" then
		UpgradeMe.Config:Show(2)
		return
	elseif args == "reset main" then
		umData.um_UI.HandMainID = ""
	elseif args == "reset off" then
		umData.um_UI.HandOffID = ""
	elseif args == "debugme" then
		UpgradeMe._debugon = not UpgradeMe._debugon
	else
		UpgradeMe.Config:SaveOutfit(args, true)
	end

end

--Command.System.Strict()
Command.Event.Attach(Command.Slash.Register("upme"), SlashHandler, addon..".SlashHandler")
Command.Event.Attach(Event.Tooltip, scrapeTooltip, addon..".Scraper")
Command.Event.Attach(Event.Mouse.Move, HideTooltip, addon..".Hider")
Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, SaveVariables, addon..".SaveVar")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, LoadVariables, addon..".LoadVar")
Command.Event.Attach(Event.Addon.Load.End, LoadComplete, addon..".LoadComplete")
Command.Event.Attach(Event.Unit.Availability.Full, PlayerLoaded, addon..".Update")
Command.Event.Attach(Event.Item.Slot, SetOutfitDirty, addon..".ValidateOutfit")