local addon, private = ...
local _equipment = {
					"helmet", "cape", "shoulders", "chest", "gloves", "belt", "legs", "feet", 
					"ranged", "neck", "trinket", "ring1", "ring2", "synergy", "focus", "seal"
					}

local function sorter(a,b)
	return a[1] < b[1]
end

local function GetOutfits()
	local oReturn = {}
	for oname, outfit in pairs(UpgradeMe.Outfits) do
		table.insert(oReturn, oname)
	end
	return oReturn
end

local function GetRoleSlot()
	return {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20"}
end

local function GetEquipSet()
	return {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20"}
end

local function GetWardrobeSet()
	return {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19"}
end

local function GetNewEquipRecord()
	local _iRec = {}
	local _twohander = false
	local _detail = UpgradeMe.GetItemDetail(Utility.Item.Slot.Equipment("handmain"))
	if _detail then _twohander = string.find(_detail.category, "twohand") end
	
	if not _twohander then
		_iRec["handmain"] = {["slot"]="handmain", ["Name"] = "", ["ID"] = nil}
		_iRec["handoff"] = {["slot"]="handoff", ["Name"] = "", ["ID"] = nil}
	else
		_iRec["twohand"] = {["slot"]="twohand", ["Name"] = "", ["ID"] = nil}
	end
	
	for i, slot in pairs(_equipment) do
		_iRec[slot..""] = {["slot"]=slot.."", ["Name"] = "", ["ID"] = nil}
	end
	return _iRec
end

local function GetOutfitCount()
	local _i = 0

	for oname, outfit in pairs(UpgradeMe.Outfits) do
		_i = _i + 1
	end

	return _i
end

function GetOutfitData()
	local _ret = {}

	_ret.Outfits = GetOutfits
	_ret.RoleSlot = GetRoleSlot
	_ret.EquipSet = GetEquipSet
	_ret.WardrobeSet = GetWardrobeSet
	_ret.OutfitCount = GetOutfitCount
	_ret.NewEquipRecord = GetNewEquipRecord

	return _ret
end
